#################################### 
#        hTP_SimpleDM v1.3         
#                                  
#     many thanks to:              
#            GODJonez              
#            TP_Pred               
#            british_assassin      
#            SuperDave             
#            Errant                
####################################

import es
import random
import popuplib
import gamethread
import playerlib
import datetime
import services
import langlib
import keyvalues

from configobj import ConfigObj
from sqlite3 import dbapi2 as sqlite

info = es.AddonInfo()
info.name        = "hTP_SimpleDM"
info.version     = "v1.3"
info.author      = "HitThePipe and TP_Predator"
info.url         = "http://forums.mattie.info/cs/forums/viewtopic.php?t=19484"
info.description = "CSS:DM In Python for ES"

class connection(object):
    def __init__(self,path):
        self.con = sqlite.connect(path)
        self.cur = self.con.cursor()
    def execute(self,sql):
        self.cur.execute(sql)
        self.con.commit()
    def query(self,sql):
        self.cur.execute(sql)
        return self.cur.fetchall()
    def close(self):
        self.con.close()
    def utfcode(self,value):
        if type(value).__name__ == 'unicode':
            return value.encode('utf-8')
        return value 
    def convertQuery(self,result):
        newresult = list()
        for row in result:
            newrow = [utfcode(item) for item in row]
            newresult.append(newrow)
        return newresult

dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')
dm_lang = langlib.Strings(es.getAddonPath('htp_dm') + '/dm_lang.ini')
dbdm = connection(es.getAddonPath('htp_dm') + '/usersettings.db')

""" Subscript handling
if int(dm_config['settings']['use_ranking']):
    es.load('htp_dm/ranking')
if int(dm_config['settings']['use_ba_bank']):
    usebank = int(dm_config['settings']['use_ba_bank'])
    es.load('htp_dm/bank')

check fraglimit option
if int(dm_config['settings']['dm_fraglimit']):
    default_fraglimit = int(es.ServerVar('mp_fraglimit'))
    es.forcevalue('mp_fraglimit', int(dm_config['settings']['dm_fraglimit']))
"""	

rw = 0
rf = 0
gg = 0
talive = 0
ctalive = 0
tkills = 0
ctkills = 0
tdeaths = 0
ctdeaths = 0
usebank = 0
default_fraglimit = 0
cplayers = {}
cweapon = {}
defaultgive = []
auth = services.use('auth')
prefix = ('#green' + dm_config['settings']['message_prefix'] + '#default')
est_ver = es.ServerVar('est_version')
es.dbgmsg(1,'*****est_ver=%s' %est_ver)


def load():
    global DDKills
    global DMMain
    global DMMenuP
    global DMMenuR1
    global menuTeamStats
    global ranks
    global gg
    global usebank

    es.set('hTP_SimpleDM','1.3')
    es.makepublic('hTP_SimpleDM')

    if es.exists('saycommand', '!level'):
        gg = 1	
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'htp_dm/send_main', 'Send Main Menu')
    if not es.exists('saycommand', 'ammo'):
        es.regsaycmd('ammo', 'htp_dm/stock_ammo', 'Restock Ammo')
    if not es.exists('saycommand', 'stats'):
        es.regsaycmd('stats', 'htp_dm/kills', 'Show player kills')
    if not es.exists('saycommand', 'teamstats'):
        es.regsaycmd('teamstats', 'htp_dm/team_stats', 'Show team stats')

    dbdm.execute("CREATE TABLE IF NOT EXISTS [UserSettings] ([SteamID]VARCHAR(30) UNIQUE NOT NULL,[Name]VARCHAR(30),[Rifle]VARCHAR(30),[Pistol]VARCHAR(30),[SendMenu]INT,[Kills]INT,[Deaths]INT,[KD]VARCHAR(10),[LastConnect]VARCHAR(30))")

    for player in es.getUseridList():
        steamid = es.getplayersteamid(player)
        getPlayer(player, steamid)
        gamethread.delayed(2, es.server.queuecmd, 'est_spawn %s 1' % player)
    			
    for item in dm_config['weapons']['Items']:
        if int(dm_config['weapons']['Items'][item]):
            defaultgive.append('item_' + item)
			
    for other in dm_config['weapons']['Others']:
        if int(dm_config['weapons']['Others'][other]):
            defaultgive.append('weapon_' + other)       

    es.msg('#multi',prefix + dm_lang('dm on'))
    set_team_ents()

    if int(dm_config['settings']['use_ranking']):
        es.load('htp_dm/ranking')
    if int(dm_config['settings']['use_ba_bank']):
        usebank = int(dm_config['settings']['use_ba_bank'])
        es.load('htp_dm/bank')

    #check fraglimit option
    if int(dm_config['settings']['dm_fraglimit']):
        default_fraglimit = int(es.ServerVar('mp_fraglimit'))
        es.forcevalue('mp_fraglimit', int(dm_config['settings']['dm_fraglimit']))


###################################################
#                 Menus Create                    #
###################################################

    menuTeamStats = popuplib.create('menuTeamStats')
    menuTeamStats.addline('Terrorist') 
    menuTeamStats.addline('-----------------')
    menuTeamStats.addline('Kills: ')
    menuTeamStats.addline('Deaths: ')
    menuTeamStats.addline('K/D: ')
    menuTeamStats.addline('=================')
    menuTeamStats.addline(' ')
    menuTeamStats.addline('Counter-Terrorist')
    menuTeamStats.addline('-----------------')
    menuTeamStats.addline('Kills: ')
    menuTeamStats.addline('Deaths: ')
    menuTeamStats.addline('K/D: ')
    menuTeamStats.addline('=================')
    menuTeamStats.addline(' ')
    menuTeamStats.addline('->0. Exit')

    DDKills = popuplib.create('dmkills_popup')
    DDKills.addline('Stats')
    DDKills.addline('----------------')
    DDKills.addline('Kills :')
    DDKills.addline('Deaths :')
    DDKills.addline('K/D Ratio :')
    DDKills.addline('-----------------')
    DDKills.addline('->0. Exit')

    DMMain = popuplib.create('dmm_popup')
    DMMain.addline(dm_lang('main menu'))
    DMMain.addline('-----------------------')
    DMMain.addline(popuplib.langstring('->1. ', dm_lang['new weapons']))
    DMMain.addline(popuplib.langstring('->2. ', dm_lang['previous weapons']))
    DMMain.addline(popuplib.langstring('->3. ', dm_lang['use same']))
    DMMain.addline(popuplib.langstring('->4. ', dm_lang['restock']))
    DMMain.menuselect = main_menuselect
    
    
    DMMenuP = popuplib.easymenu('dmp_popup', None, menup_menuselect)
    DMMenuP.settitle('Select Pistol')
    for pistol in dm_config['weapons']['Pistols']:
        if int(dm_config['weapons']['Pistols'][pistol]):
            DMMenuP.addoption('weapon_' + pistol, pistol)

    DMMenuR1 = popuplib.easymenu('dmr1_popup',None, menur1_menuselect)
    DMMenuR1.settitle('Select Rifle')
    for rifle in dm_config['weapons']['Rifles']:
        if int(dm_config['weapons']['Rifles'][rifle]):
            DMMenuR1.addoption('weapon_' + rifle, rifle)
    
    
    
###################################################
#                Menus Response                   #
###################################################

def main_menuselect(userid, choice, popupid):
    team = es.getplayerteam(userid)
    if choice == 1:
        if not popuplib.isqueued('dmp_popup', userid):
            DMMenuP.send(userid)
    elif choice == 2:
        muser = playerlib.getPlayer(userid)
        if muser.get('teamid') > 1:
            GiveWeapons(userid,team)
    elif choice == 3:
        GiveWeapons(userid,team)	
        cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],'0')
        es.tell (userid, '#multi', prefix + dm_lang('auto send'))
    elif choice == 4:
        auser = playerlib.getPlayer(userid)
        auser.set('ammo', ['primary', '120'])
        auser.set('ammo', ['secondary', '120'])

def menup_menuselect(userid, choice, popupid):
    if not popuplib.isqueued('dmr1_popup', userid):
        DMMenuR1.send(userid)
    cplayers[userid] = (cplayers[userid][0],choice,cplayers[userid][2])
    dbdm.execute("UPDATE UserSettings SET Pistol='%s' WHERE SteamID='%s'" % (choice, es.getplayersteamid(userid)))
	
def menur1_menuselect(userid, choice, popupid):
    cplayers[userid] = (choice,cplayers[userid][1],cplayers[userid][2]) 
    muser = playerlib.getPlayer(userid)
    if muser.get('teamid') > 1:
        team = es.getplayerteam(userid)
        GiveWeapons(userid,team)	
    steamid = es.getplayersteamid(userid)
    dbdm.execute("UPDATE UserSettings SET Rifle='%s' WHERE SteamID='%s'" % (choice, steamid))


###################################################
#          Custom Events Creation                 #
###################################################

def deposit(userid,steamid,weapon=None,headshot=None):
    es.event('initialize','htp_deposit')
    es.event('setint','htp_deposit','userid',userid)
    es.event('setstring','htp_deposit','steamid',steamid)
    es.event('setstring','htp_deposit','weapon',weapon)
    es.event('setint','htp_deposit','headshot',headshot)
    es.event('fire','htp_deposit')
    es.dbgmsg(1,'*****event htp_deposit fired')

def withdraw(userid,steamid,weapon=None,headshot=None):
    es.event('initialize','htp_withdraw')
    es.event('setint','htp_withdraw','userid',userid)
    es.event('setstring','htp_withdraw','steamid',steamid)
    es.event('setstring','htp_withdraw','weapon',weapon)
    es.event('setint','htp_withdraw','headshot',headshot)
    es.event('fire','htp_withdraw')
    es.dbgmsg(1,'*****event htp_withdraw fired')

def weapon(userid,primary,secondary):
    steamid = es.getplayersteamid(userid)
    es.event('initialize','htp_weapon')
    es.event('setint','htp_weapon','userid',userid)
    es.event('setstring','htp_weapon','steamid',steamid)
    es.event('setstring','htp_weapon','primary',primary)
    es.event('setstring','htp_weapon','secondary',secondary)
    es.event('fire','htp_weapon')


###################################################
#                Standard Events                  #
###################################################


""" For testing 
def htp_weapon(event_var):
    es.dbgmsg(1,'*****htp_weapon received')
    es.dbgmsg(1,'****userid=%s steamid=%s primary=%s secondary=%s' %(event_var['userid'],event_var['steamid'],event_var['primary'],event_var['secondary']))

def gg_load(event_var):
    es.dbgmsg(1,'*****gg_load received')
    global gg
    gg = 1
	
def gg_unload(event_var):
    global gg
    es.dbgmsg(1,'*****gg_unload received')
    gg = 0
"""

def player_activate(event_var):
    if event_var['es_steamid'] not in ('STEAM_ID_PENDING','BOT'):
        es.tell (event_var['userid'], '#multi', '#green[DM Commands]#default \'guns\' \'ammo\' \'stats\' \'top #\' \'rank\' ')
        getPlayer(event_var['userid'], event_var['es_steamid'])    
    else:
        es.tell (event_var['userid'], '#multi', '%s Your STEAM_ID has not been validated yet.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s Cannot load your settings.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s You will be given random weapons until validation.' %prefix)
        #getbotweapons(event_var['userid'])  

def player_changename(event_var):
    dbdm.execute("UPDATE UserSettings SET Name='%s' WHERE SteamID='%s'" %(event_var['newname'],event_var['es_steamid']))

def player_disconnect(event_var):
    global cplayers
    userid = event_var['userid']
    userid = int(userid)
    steamid = event_var['es_steamid']
    if steamid != 'BOT':
        kills = dbdm.query("SELECT Kills FROM UserSettings WHERE SteamID='%s'" %steamid)[0]
        if kills[0]:
            dbdm.execute("UPDATE UserSettings SET Rifle='%s',Pistol='%s',SendMenu='%s' WHERE SteamID='%s'" %(cplayers[userid][0],cplayers[userid][1],cplayers[userid][2],steamid))
            #del cplayers[userid]
        else:
            dbdm.execute("DELETE FROM UserSettings WHERE SteamID='%s'" %steamid)
            #del cplayers[userid]
        del cplayers[userid]

def player_death(event_var):
    global rw,talive,ctalive,tkills,ctkills,tdeaths,ctdeaths,t_teamindex,ct_teamindex
    es.dbgmsg(1,'*****player_death')
    es.dbgmsg(1,'*****attackerid=%s' %event_var['attacker'])
    if not gg:
        teamdeath = event_var['es_userteam']
        if teamdeath == '2':
            talive -= 1
            team = '#t'
            ctkills += 1
            es.setindexprop(ct_teamindex, 'CCSTeam.baseclass.m_iScore', ctkills)
            tdeaths += 1
        if teamdeath == '3':
            ctalive -= 1
            team = '#ct'
            tkills += 1
            es.setindexprop(t_teamindex, 'CCSTeam.baseclass.m_iScore', tkills)
            ctdeaths += 1
        es.dbgmsg(1,'*****tkills=%d ctkills=%d' %(tkills,ctkills))
        es.dbgmsg(1,'*****tdeaths=%d ctdeaths=%d' %(tdeaths,ctdeaths))
        if talive == 1 or ctalive == 1:
            teamlist = playerlib.getPlayerList(team)
            for player in teamlist:
                player.set('health', 1000)
                gamethread.delayed(3, player.set, ('health', 100))
        
            
    gamethread.delayed(2.5, es.server.queuecmd, 'est_spawn %s' % event_var['userid'])
    if event_var['es_userteam'] != event_var['es_attackerteam'] and event_var['es_attackerteam'] in ('2','3'):
        attackersteam = event_var['es_attackersteamid']
        attackerid = event_var['attacker']
        steamid = event_var['es_steamid']
        userid = event_var['userid']
        if attackersteam != 'BOT':
            if steamid != 'BOT':
                dbdm.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                dbdm.execute("UPDATE UserSettings SET Kills=(SELECT sum(Kills+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))
                kd_update(steamid)
                kd_update(attackersteam)
                if usebank:
                    deposit(attackerid,attackersteam,event_var['weapon'],event_var['headshot'])
                    withdraw(userid,steamid,event_var['weapon'],event_var['headshot'])
            es.dbgmsg(1,'*****count_bot_kills_deaths=%s' %dm_config['settings']['count_bot_kills_deaths'])
            if dm_config['settings']['count_bot_kills_deaths'] == '1':
                dbdm.execute("UPDATE UserSettings SET Kills=(SELECT sum(Kills+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))
                kd_update(attackersteam)
                es.dbgmsg(1,'*****usebank=%d' %usebank)
                if usebank:
                    es.dbgmsg(1,'*****deposit should fire')
                    deposit(attackerid,attackersteam,event_var['weapon'],event_var['headshot'])

        if dm_config['settings']['count_bot_kills_deaths'] == '1':
            if steamid != 'BOT':
                dbdm.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                kd_update(steamid)
                if usebank:
                    withdraw(userid,steamid,event_var['weapon'],event_var['headshot'])
    rw += 1
    if rw > 10:
        remove_weapons()
        rw = 0

def es_map_start(event_var):
    global talive,ctalive,tkills,ctkills,tdeaths,ctdeaths,default_fraglimit
    talive = 0
    ctalive = 0
    tkills = 0
    ctkills = 0
    tdeaths = 0
    ctdeaths = 0
    es.dbgmsg(1, '***** Map start')
    popuplib.close('dmm_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmp_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmr1_popup', playerlib.getUseridList('#human'))
    date = datetime.date.today() - datetime.timedelta(int(dm_config['settings']['clear_inactive_users']))
    dbdm.execute("DELETE FROM UserSettings WHERE LastConnect<'%s'" %date)
    gamethread.delayed(1, set_team_ents)
    if int(dm_config['settings']['dm_fraglimit']):
        default_fraglimit = int(es.ServerVar('mp_fraglimit'))
        es.forcevalue('mp_fraglimit', int(dm_config['settings']['dm_fraglimit']))
         
def item_pickup(event_var):   
    if not rf:
        userid = int(event_var['userid'])
        if not es.isbot(userid):
            es.dbgmsg(1,'*****item_pickup')
            item = event_var['item']
            if item in ('glock','usp','deagle','p228','fiveseven','elite','m4a1','ak47','awp','famas','galil','sg552','aug','sg550','g3sg1','scout','m3','xm1014','m249','tmp','mac10','mp5navy','ump45','p90'):
                if item in ('glock','usp','deagle','p228','fiveseven','elite'):
                    secondary = item
                    primary = cweapon[userid][0]
                else:
                    primary = item
                    secondary = cweapon[userid][1]
                cweapon[userid] = (primary,secondary)
                weapon(userid,primary,secondary)   

def player_team(event_var):
    global talive,ctalive
    team = event_var['team']    
    if event_var['disconnect'] and int(event_var['team']) > 1:
        gamethread.delayed(1, es.server.cmd, 'est_spawn %s 1' % event_var['userid'])
    if team == '2':
        talive -= 1
        ctalive += 1
    if team == '3':
        ctalive -= 1
        talive += 1	
	
def player_spawn(event_var):
    global talive,ctalive
    if not gg:
        team = event_var['es_userteam']
        if int(team) > 1:
            userid = int(event_var['userid'])
            steamid = event_var['es_steamid']
            current_player = playerlib.getPlayer(userid)
            current_player.set('health', 999)
            gamethread.delayed(3, current_player.set, ('health', 100))
            if steamid not in ('BOT', 'STEAM_ID_PENDING'):
                if cplayers[userid]:
                    if cplayers[userid][2] == '1':
                        if not popuplib.isqueued('dmm_popup', userid):
                            popuplib.send('dmm_popup', userid)
                    else:
                        GiveWeapons(userid,team)
                else:
                    getplayer(userid,steamid)
            else:            
                getbotweapons(userid,team)
            if team == '2':
                talive =+ 1
            if team == '3':
                ctalive += 1

def round_end(event_var):
    global talive,ctalive
    talive = 0
    ctalive = 0

def round_start(event_var):
    if not gg:
        rf = 0
        es.setindexprop(ct_teamindex, 'CCSTeam.baseclass.m_iScore', ctkills)
        es.setindexprop(t_teamindex, 'CCSTeam.baseclass.m_iScore', tkills)
        userid = int(es.getuserid())
        if int(dm_config['settings']['disable_map_objectives']):
            mapname = str(es.ServerVar('eventscripts_currentmap'))
            if mapname.startswith('cs_'):
                hostages = es.createentitylist('hostage_entity')
                for hostage in hostages:
                    es.delayed(0.1, "es_remove %d" % hostage)
                if int(dm_config['settings']['disable_map_objectives']) == 2:
                    targets = es.createentitylist('func_hostage_rescue')
                    if userid:
                        for target in targets:
                            es.delayed(0.1, "es_remove %d" % target)    
            elif mapname.startswith('de_'):
                es.remove('weapon_c4')
                if int(dm_config['settings']['disable_map_objectives']) == 2:
                    targets = es.createentitylist('func_bomb_target')
                    if userid:
                        for target in targets:
                            es.delayed(0.1, "es_remove %d" % target)
                
        gamethread.delayed(3,remove_weapons())
        if userid:
            es.server.queuecmd('es_xfire %d func_buyzone disable' % userid)

def weapon_reload(event_var):
    auser = playerlib.getPlayer(event_var['userid'])
    auser.set('ammo', ['primary', '120'])
    auser.set('ammo', ['secondary', '30'])	

def unload():
    popuplib.delete('dmm_popup')
    popuplib.delete('dmkills_popup')
    popuplib.delete('dmp_popup')
    popuplib.delete('dmr1_popup')
    popuplib.delete('menuTeamStats')
    es.unregsaycmd('guns')
    es.unregsaycmd('ammo')
    es.unregsaycmd('stats')
    es.unregsaycmd('teamstats')
    dbdm.close
    es.unload('htp_dm/ranking')
    es.unload('htp_dm/bank')
    es.msg('#multi', prefix + dm_lang('dm off'))
    if int(dm_config['settings']['dm_fraglimit']):
        es.forcevalue('mp_fraglimit', default_fraglimit)

###################################################
#                  Functions                      #
###################################################

def set_team_ents():
    es.dbgmsg(1,'*****set_team_ents')
    global t_teamindex,ct_teamindex
    tm_ents = es.createentitylist('cs_team_manager')
    es.dbgmsg(1,'*****tm_ents=%s' %tm_ents)
    for team_index in tm_ents:
        es.dbgmsg(1,'*****team_index=%s team=%s' %(team_index,es.getindexprop(team_index,'CCSTeam.baseclass.m_iTeamNum')))
        team = es.getindexprop(team_index,'CCSTeam.baseclass.m_iTeamNum')
        if team == 2:
            t_teamindex = int(team_index)
            es.dbgmsg(1,'*****t_teamindex=%d' %t_teamindex)
        elif team == 3:
            ct_teamindex = int(team_index)
            es.dbgmsg(1,'*****ct_teamindex=%d' %ct_teamindex)	


def team_stats():
    es.dbgmsg(1,'*****team_stats')
    global menuTeamStats,tkills,ctkills,tdeaths,ctdeaths
    userid = es.getcmduserid()
    menuTeamStats.modline(3,'Kills: %d' %tkills)
    menuTeamStats.modline(4,'Deaths: %d' %tdeaths)
    kd = float((tkills + .0)/tdeaths)
    menuTeamStats.modline(5,'K/D: %.2f' %kd)
    menuTeamStats.modline(10,'Kills: %d' %ctkills)
    menuTeamStats.modline(11,'Deaths: %d' %ctdeaths)
    kd = float((ctkills + .0)/ctdeaths)
    menuTeamStats.modline(12,'K/D: %.2f' %kd)
    menuTeamStats.send(userid)

def stock_ammo():
    if not gg:
        user = es.getcmduserid()
        auser = playerlib.getPlayer(user)
        auser.set('ammo', ['primary', '120'])
        auser.set('ammo', ['secondary', '120'])
    else:
        es.tell (userid, '#multi', '%s That command is disabled during GunGame' %prefix)			
	
def GiveWeapons (userid,team):
    rifle = cplayers[userid][0]
    pistol = cplayers[userid][1]
    es.server.queuecmd('es_xgive %s player_weaponstrip' %userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(1, equip_player, (userid,team,pistol,rifle))

def equip_player(userid,team,pistol,rifle):
    for give in defaultgive:
        if give != 'item_defuser':
            es.server.queuecmd('es_xgive %s ' %userid + give)
        else:
            if team == '3':
                player = playerlib.getPlayer(userid)
                player.set('defuser',1) 
    es.server.queuecmd('es_xgive %s %s' %(userid,pistol))
    es.server.queuecmd('es_xgive %s %s' %(userid,rifle))
    if not es.isbot(userid):
        cweapon[int(userid)] = (rifle[7:],pistol[7:])
        es.dbgmsg(1,'*****cweapon[%s]=%s' %(userid,cweapon[int(userid)]))
        weapon(userid,rifle[7:],pistol[7:])

def kills():
    userid = es.getcmduserid()
    usersteam = es.getplayersteamid(userid)
    (kills,deaths) = dbdm.query("SELECT Kills,Deaths FROM UserSettings WHERE SteamID='%s'" % usersteam)[0]
    kd = (kills + .0) / deaths
    DDKills.modline(3, 'Kills : %s' % kills)
    DDKills.modline(4, 'Deaths : %s' % deaths)
    DDKills.modline(5, 'K/D Ratio : %.2f' % kd)
    DDKills.send(userid)

def getPlayer(userid,steamid):
    if not es.isbot(userid):
        settings = dbdm.query("SELECT Rifle,Pistol,SendMenu,Name FROM UserSettings WHERE SteamID='%s'" % steamid)
        name = es.getplayername(userid)
        userid = int(userid)        
        if not settings:
            dbdm.execute("INSERT INTO UserSettings ('SteamID', 'Name', 'Rifle', 'Pistol', 'SendMenu', 'Kills', 'Deaths', 'LastConnect') VALUES ('%s', '%s', 'weapon_m4a1', 'weapon_deagle', '1', 0, 0, '%s')" % (steamid, name, datetime.date.today()))
            cplayers[userid] = ('weapon_m4a1', 'weapon_deagle', '1')
        else:
            settings = settings[0] 
            cplayers[userid] = settings
            if name == cplayers[userid][3]:
                dbdm.execute("UPDATE UserSettings SET LastConnect='%s' WHERE SteamID='%s'" %(datetime.date.today(),steamid))
            else:
                dbdm.execute("UPDATE UserSettings SET Name='%s',LastConnect='%s' WHERE SteamID='%s'" %(name,datetime.date.today(),steamid))
            cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],cplayers[userid][2])
        cweapon[userid] = ('None','None')

def kd_update(steamid):
    if dbdm.query("SELECT Deaths FROM UserSettings WHERE SteamID='%s'" %steamid):
        dbdm.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.) / Deaths) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
    else:
        dbdm.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.)) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))

def send_main():
    if not gg:
        userid = es.getcmduserid()
        DMMain.send(userid)
        cplayers[userid] = (cplayers[userid][0],cplayers[userid][1], '1')
        es.tell (userid, '#multi', '%s Menu Enabled' %prefix)
    else:
        es.tell (userid, '#multi', '%s That command is disabled during GunGame' %prefix)	
	
def remove_weapons():
    es.dbgmsg(1,'*****est_ver=%s' %est_ver)
    if est_ver == '0.420':
        es.server.queuecmd('est_Dissolve cs_ragdoll')
    else:
        es.server.queuecmd('est_DeleteRagDolls')
    es.server.queuecmd('est_RemoveIdle weapon')
    es.server.queuecmd('est_RemoveIdle item')

def getbotweapons(userid,team):
    pistol = random.choice(('weapon_glock', 'weapon_deagle', 'weapon_usp', 'weapon_elite', 'weapon_usp', 'weapon_p228', 'weapon_fiveseven'))
    rifle = random.choice(('weapon_m4a1', 'weapon_ak47', 'weapon_awp', 'weapon_mp5navy', 'weapon_p90', 'weapon_galil', 'weapon_scout', 'weapon_sg552', 'weapon_aug'))
    es.server.queuecmd('es_xgive %s player_weaponstrip' %userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(1, equip_player, (userid,team,pistol,rifle))

   

